import numpy as np
import tensorflow as tf
import ktc
import onnx

import jieba
import jieba.analyse


def jiebacut(inputa):
  pre_content = inputa
  #全切分模式
  pre_content = jieba.cut(pre_content,cut_all=True)
      
  #TFIDF，過濾停用字
  jieba.analyse.set_stop_words("stopword/stopwords.txt")    
  tags = jieba.analyse.extract_tags(','.join(pre_content), topK=10)
  pre_content = ','.join(tags)
  
  return pre_content


def test():
    #訓練集與測試集
    x_train = []
    y_train = []
    subject ={
        '耳鼻喉科':0,
        '神經內科':1
    }
    with open('data/train.txt', encoding='utf-8') as content:
        data = content.readlines()       
        for s in data:      
          s = s.strip('\n')
          str = s.split(' ')
          x_train.append(jiebacut(str[0]))
          y_train.append(subject[str[1]])      
    wordset = [list(s) for s in x_train] 
    return wordset

def preprocess(input_file):
    #讀取辭典
    tokenizer = tf.keras.preprocessing.text.Tokenizer(filters='')
    words = test()
    tokenizer.fit_on_texts(words)       
    
    with open(input_file , 'r' , encoding='utf-8' ) as f:
        word = f.read()
        word = [[s for s in word]]       
        #處理新句
        myTxtTensor=tokenizer.texts_to_sequences(word)
        myTxtTensor = tf.keras.preprocessing.sequence.pad_sequences(
                myTxtTensor,
                padding='post',
                truncating='post',
                maxlen=30
        )   
    return np.array([myTxtTensor/1.0])


def readlabel():
    with open('data/label.txt',"r", encoding='utf-8') as content:
        sentences = content.read().split('\n')
        
        labels = list()
        results = list()
        for i in sentences:
            label , result = i.split(' ')
            labels.append(label)
            results.append(result)
        item = list()
        item.append(labels)
        item.append(results)
    return  item

km = ktc.ModelConfig(32769, "0001", "720", onnx_path="opt.onnx")
# Preprocess images and create the input mapping
input_data =[]

for i in range(0,24):
    input_data.append(preprocess('data/'+str(i)+'.txt'))
  

# Quantization
bie_model_path = km.analysis({"serving_default_dense_82_input": input_data})
km2 = ktc.ModelConfig(32770, "0001", "720", bie_path=bie_model_path)
compile_result = ktc.compile([km2])
print("\nCompile done. Saved Nef file to '" + str(compile_result) + "'")